// Compiled by ClojureScript 1.10.238 {}
goog.provide('cljs_http.core');
goog.require('cljs.core');
goog.require('goog.net.EventType');
goog.require('goog.net.ErrorCode');
goog.require('goog.net.XhrIo');
goog.require('goog.net.Jsonp');
goog.require('cljs_http.util');
goog.require('cljs.core.async');
goog.require('clojure.string');
cljs_http.core.pending_requests = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
 * Attempt to close the given channel and abort the pending HTTP request
 *   with which it is associated.
 */
cljs_http.core.abort_BANG_ = (function cljs_http$core$abort_BANG_(channel){
var temp__5457__auto__ = cljs.core.deref.call(null,cljs_http.core.pending_requests).call(null,channel);
if(cljs.core.truth_(temp__5457__auto__)){
var req = temp__5457__auto__;
cljs.core.swap_BANG_.call(null,cljs_http.core.pending_requests,cljs.core.dissoc,channel);

cljs.core.async.close_BANG_.call(null,channel);

if(cljs.core.truth_(req.hasOwnProperty("abort"))){
return req.abort();
} else {
return new cljs.core.Keyword(null,"jsonp","jsonp",226119588).cljs$core$IFn$_invoke$arity$1(req).cancel(new cljs.core.Keyword(null,"request","request",1772954723).cljs$core$IFn$_invoke$arity$1(req));
}
} else {
return null;
}
});
cljs_http.core.aborted_QMARK_ = (function cljs_http$core$aborted_QMARK_(xhr){
return cljs.core._EQ_.call(null,xhr.getLastErrorCode(),goog.net.ErrorCode.ABORT);
});
/**
 * Takes an XhrIo object and applies the default-headers to it.
 */
cljs_http.core.apply_default_headers_BANG_ = (function cljs_http$core$apply_default_headers_BANG_(xhr,headers){
var seq__6094 = cljs.core.seq.call(null,cljs.core.map.call(null,cljs_http.util.camelize,cljs.core.keys.call(null,headers)));
var chunk__6099 = null;
var count__6100 = (0);
var i__6101 = (0);
while(true){
if((i__6101 < count__6100)){
var h_name = cljs.core._nth.call(null,chunk__6099,i__6101);
var seq__6102_6106 = cljs.core.seq.call(null,cljs.core.vals.call(null,headers));
var chunk__6103_6107 = null;
var count__6104_6108 = (0);
var i__6105_6109 = (0);
while(true){
if((i__6105_6109 < count__6104_6108)){
var h_val_6110 = cljs.core._nth.call(null,chunk__6103_6107,i__6105_6109);
xhr.headers.set(h_name,h_val_6110);


var G__6111 = seq__6102_6106;
var G__6112 = chunk__6103_6107;
var G__6113 = count__6104_6108;
var G__6114 = (i__6105_6109 + (1));
seq__6102_6106 = G__6111;
chunk__6103_6107 = G__6112;
count__6104_6108 = G__6113;
i__6105_6109 = G__6114;
continue;
} else {
var temp__5457__auto___6115 = cljs.core.seq.call(null,seq__6102_6106);
if(temp__5457__auto___6115){
var seq__6102_6116__$1 = temp__5457__auto___6115;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__6102_6116__$1)){
var c__4319__auto___6117 = cljs.core.chunk_first.call(null,seq__6102_6116__$1);
var G__6118 = cljs.core.chunk_rest.call(null,seq__6102_6116__$1);
var G__6119 = c__4319__auto___6117;
var G__6120 = cljs.core.count.call(null,c__4319__auto___6117);
var G__6121 = (0);
seq__6102_6106 = G__6118;
chunk__6103_6107 = G__6119;
count__6104_6108 = G__6120;
i__6105_6109 = G__6121;
continue;
} else {
var h_val_6122 = cljs.core.first.call(null,seq__6102_6116__$1);
xhr.headers.set(h_name,h_val_6122);


var G__6123 = cljs.core.next.call(null,seq__6102_6116__$1);
var G__6124 = null;
var G__6125 = (0);
var G__6126 = (0);
seq__6102_6106 = G__6123;
chunk__6103_6107 = G__6124;
count__6104_6108 = G__6125;
i__6105_6109 = G__6126;
continue;
}
} else {
}
}
break;
}

var G__6127 = seq__6094;
var G__6128 = chunk__6099;
var G__6129 = count__6100;
var G__6130 = (i__6101 + (1));
seq__6094 = G__6127;
chunk__6099 = G__6128;
count__6100 = G__6129;
i__6101 = G__6130;
continue;
} else {
var temp__5457__auto__ = cljs.core.seq.call(null,seq__6094);
if(temp__5457__auto__){
var seq__6094__$1 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__6094__$1)){
var c__4319__auto__ = cljs.core.chunk_first.call(null,seq__6094__$1);
var G__6131 = cljs.core.chunk_rest.call(null,seq__6094__$1);
var G__6132 = c__4319__auto__;
var G__6133 = cljs.core.count.call(null,c__4319__auto__);
var G__6134 = (0);
seq__6094 = G__6131;
chunk__6099 = G__6132;
count__6100 = G__6133;
i__6101 = G__6134;
continue;
} else {
var h_name = cljs.core.first.call(null,seq__6094__$1);
var seq__6095_6135 = cljs.core.seq.call(null,cljs.core.vals.call(null,headers));
var chunk__6096_6136 = null;
var count__6097_6137 = (0);
var i__6098_6138 = (0);
while(true){
if((i__6098_6138 < count__6097_6137)){
var h_val_6139 = cljs.core._nth.call(null,chunk__6096_6136,i__6098_6138);
xhr.headers.set(h_name,h_val_6139);


var G__6140 = seq__6095_6135;
var G__6141 = chunk__6096_6136;
var G__6142 = count__6097_6137;
var G__6143 = (i__6098_6138 + (1));
seq__6095_6135 = G__6140;
chunk__6096_6136 = G__6141;
count__6097_6137 = G__6142;
i__6098_6138 = G__6143;
continue;
} else {
var temp__5457__auto___6144__$1 = cljs.core.seq.call(null,seq__6095_6135);
if(temp__5457__auto___6144__$1){
var seq__6095_6145__$1 = temp__5457__auto___6144__$1;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__6095_6145__$1)){
var c__4319__auto___6146 = cljs.core.chunk_first.call(null,seq__6095_6145__$1);
var G__6147 = cljs.core.chunk_rest.call(null,seq__6095_6145__$1);
var G__6148 = c__4319__auto___6146;
var G__6149 = cljs.core.count.call(null,c__4319__auto___6146);
var G__6150 = (0);
seq__6095_6135 = G__6147;
chunk__6096_6136 = G__6148;
count__6097_6137 = G__6149;
i__6098_6138 = G__6150;
continue;
} else {
var h_val_6151 = cljs.core.first.call(null,seq__6095_6145__$1);
xhr.headers.set(h_name,h_val_6151);


var G__6152 = cljs.core.next.call(null,seq__6095_6145__$1);
var G__6153 = null;
var G__6154 = (0);
var G__6155 = (0);
seq__6095_6135 = G__6152;
chunk__6096_6136 = G__6153;
count__6097_6137 = G__6154;
i__6098_6138 = G__6155;
continue;
}
} else {
}
}
break;
}

var G__6156 = cljs.core.next.call(null,seq__6094__$1);
var G__6157 = null;
var G__6158 = (0);
var G__6159 = (0);
seq__6094 = G__6156;
chunk__6099 = G__6157;
count__6100 = G__6158;
i__6101 = G__6159;
continue;
}
} else {
return null;
}
}
break;
}
});
/**
 * Takes an XhrIo object and sets response-type if not nil.
 */
cljs_http.core.apply_response_type_BANG_ = (function cljs_http$core$apply_response_type_BANG_(xhr,response_type){
return xhr.setResponseType((function (){var G__6160 = response_type;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"array-buffer","array-buffer",519008380),G__6160)){
return goog.net.XhrIo.ResponseType.ARRAY_BUFFER;
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"blob","blob",1636965233),G__6160)){
return goog.net.XhrIo.ResponseType.BLOB;
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"document","document",-1329188687),G__6160)){
return goog.net.XhrIo.ResponseType.DOCUMENT;
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"text","text",-1790561697),G__6160)){
return goog.net.XhrIo.ResponseType.TEXT;
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"default","default",-1987822328),G__6160)){
return goog.net.XhrIo.ResponseType.DEFAULT;
} else {
if(cljs.core._EQ_.call(null,null,G__6160)){
return goog.net.XhrIo.ResponseType.DEFAULT;
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__6160)].join('')));

}
}
}
}
}
}
})());
});
/**
 * Builds an XhrIo object from the request parameters.
 */
cljs_http.core.build_xhr = (function cljs_http$core$build_xhr(p__6161){
var map__6162 = p__6161;
var map__6162__$1 = ((((!((map__6162 == null)))?(((((map__6162.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6162.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6162):map__6162);
var request = map__6162__$1;
var with_credentials_QMARK_ = cljs.core.get.call(null,map__6162__$1,new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222));
var default_headers = cljs.core.get.call(null,map__6162__$1,new cljs.core.Keyword(null,"default-headers","default-headers",-43146094));
var response_type = cljs.core.get.call(null,map__6162__$1,new cljs.core.Keyword(null,"response-type","response-type",-1493770458));
var timeout = (function (){var or__3922__auto__ = new cljs.core.Keyword(null,"timeout","timeout",-318625318).cljs$core$IFn$_invoke$arity$1(request);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return (0);
}
})();
var send_credentials = (((with_credentials_QMARK_ == null))?true:with_credentials_QMARK_);
var G__6164 = (new goog.net.XhrIo());
cljs_http.core.apply_default_headers_BANG_.call(null,G__6164,default_headers);

cljs_http.core.apply_response_type_BANG_.call(null,G__6164,response_type);

G__6164.setTimeoutInterval(timeout);

G__6164.setWithCredentials(send_credentials);

return G__6164;
});
cljs_http.core.error_kw = cljs.core.PersistentHashMap.fromArrays([(0),(7),(1),(4),(6),(3),(2),(9),(5),(8)],[new cljs.core.Keyword(null,"no-error","no-error",1984610064),new cljs.core.Keyword(null,"abort","abort",521193198),new cljs.core.Keyword(null,"access-denied","access-denied",959449406),new cljs.core.Keyword(null,"custom-error","custom-error",-1565161123),new cljs.core.Keyword(null,"http-error","http-error",-1040049553),new cljs.core.Keyword(null,"ff-silent-error","ff-silent-error",189390514),new cljs.core.Keyword(null,"file-not-found","file-not-found",-65398940),new cljs.core.Keyword(null,"offline","offline",-107631935),new cljs.core.Keyword(null,"exception","exception",-335277064),new cljs.core.Keyword(null,"timeout","timeout",-318625318)]);
/**
 * Execute the HTTP request corresponding to the given Ring request
 *   map and return a core.async channel.
 */
cljs_http.core.xhr = (function cljs_http$core$xhr(p__6165){
var map__6166 = p__6165;
var map__6166__$1 = ((((!((map__6166 == null)))?(((((map__6166.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6166.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6166):map__6166);
var request = map__6166__$1;
var request_method = cljs.core.get.call(null,map__6166__$1,new cljs.core.Keyword(null,"request-method","request-method",1764796830));
var headers = cljs.core.get.call(null,map__6166__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var body = cljs.core.get.call(null,map__6166__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var with_credentials_QMARK_ = cljs.core.get.call(null,map__6166__$1,new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222));
var cancel = cljs.core.get.call(null,map__6166__$1,new cljs.core.Keyword(null,"cancel","cancel",-1964088360));
var channel = cljs.core.async.chan.call(null);
var request_url = cljs_http.util.build_url.call(null,request);
var method = cljs.core.name.call(null,(function (){var or__3922__auto__ = request_method;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return new cljs.core.Keyword(null,"get","get",1683182755);
}
})());
var headers__$1 = cljs_http.util.build_headers.call(null,headers);
var xhr = cljs_http.core.build_xhr.call(null,request);
cljs.core.swap_BANG_.call(null,cljs_http.core.pending_requests,cljs.core.assoc,channel,xhr);

xhr.listen(goog.net.EventType.COMPLETE,((function (channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel){
return (function (evt){
var target = evt.target;
var response = new cljs.core.PersistentArrayMap(null, 7, [new cljs.core.Keyword(null,"status","status",-1997798413),target.getStatus(),new cljs.core.Keyword(null,"success","success",1890645906),target.isSuccess(),new cljs.core.Keyword(null,"body","body",-2049205669),target.getResponse(),new cljs.core.Keyword(null,"headers","headers",-835030129),cljs_http.util.parse_headers.call(null,target.getAllResponseHeaders()),new cljs.core.Keyword(null,"trace-redirects","trace-redirects",-1149427907),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [request_url,target.getLastUri()], null),new cljs.core.Keyword(null,"error-code","error-code",180497232),cljs_http.core.error_kw.call(null,target.getLastErrorCode()),new cljs.core.Keyword(null,"error-text","error-text",2021893718),target.getLastError()], null);
if(cljs.core.not.call(null,cljs_http.core.aborted_QMARK_.call(null,xhr))){
cljs.core.async.put_BANG_.call(null,channel,response);
} else {
}

cljs.core.swap_BANG_.call(null,cljs_http.core.pending_requests,cljs.core.dissoc,channel);

if(cljs.core.truth_(cancel)){
cljs.core.async.close_BANG_.call(null,cancel);
} else {
}

return cljs.core.async.close_BANG_.call(null,channel);
});})(channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel))
);

xhr.send(request_url,method,body,headers__$1);

if(cljs.core.truth_(cancel)){
var c__3814__auto___6189 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___6189,channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___6189,channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel){
return (function (state_6178){
var state_val_6179 = (state_6178[(1)]);
if((state_val_6179 === (1))){
var state_6178__$1 = state_6178;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6178__$1,(2),cancel);
} else {
if((state_val_6179 === (2))){
var inst_6169 = (state_6178[(2)]);
var inst_6170 = xhr.isComplete();
var inst_6171 = cljs.core.not.call(null,inst_6170);
var state_6178__$1 = (function (){var statearr_6180 = state_6178;
(statearr_6180[(7)] = inst_6169);

return statearr_6180;
})();
if(inst_6171){
var statearr_6181_6190 = state_6178__$1;
(statearr_6181_6190[(1)] = (3));

} else {
var statearr_6182_6191 = state_6178__$1;
(statearr_6182_6191[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6179 === (3))){
var inst_6173 = xhr.abort();
var state_6178__$1 = state_6178;
var statearr_6183_6192 = state_6178__$1;
(statearr_6183_6192[(2)] = inst_6173);

(statearr_6183_6192[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6179 === (4))){
var state_6178__$1 = state_6178;
var statearr_6184_6193 = state_6178__$1;
(statearr_6184_6193[(2)] = null);

(statearr_6184_6193[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6179 === (5))){
var inst_6176 = (state_6178[(2)]);
var state_6178__$1 = state_6178;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6178__$1,inst_6176);
} else {
return null;
}
}
}
}
}
});})(c__3814__auto___6189,channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel))
;
return ((function (switch__3724__auto__,c__3814__auto___6189,channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel){
return (function() {
var cljs_http$core$xhr_$_state_machine__3725__auto__ = null;
var cljs_http$core$xhr_$_state_machine__3725__auto____0 = (function (){
var statearr_6185 = [null,null,null,null,null,null,null,null];
(statearr_6185[(0)] = cljs_http$core$xhr_$_state_machine__3725__auto__);

(statearr_6185[(1)] = (1));

return statearr_6185;
});
var cljs_http$core$xhr_$_state_machine__3725__auto____1 = (function (state_6178){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_6178);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e6186){if((e6186 instanceof Object)){
var ex__3728__auto__ = e6186;
var statearr_6187_6194 = state_6178;
(statearr_6187_6194[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6178);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6186;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6195 = state_6178;
state_6178 = G__6195;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs_http$core$xhr_$_state_machine__3725__auto__ = function(state_6178){
switch(arguments.length){
case 0:
return cljs_http$core$xhr_$_state_machine__3725__auto____0.call(this);
case 1:
return cljs_http$core$xhr_$_state_machine__3725__auto____1.call(this,state_6178);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs_http$core$xhr_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs_http$core$xhr_$_state_machine__3725__auto____0;
cljs_http$core$xhr_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs_http$core$xhr_$_state_machine__3725__auto____1;
return cljs_http$core$xhr_$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___6189,channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel))
})();
var state__3816__auto__ = (function (){var statearr_6188 = f__3815__auto__.call(null);
(statearr_6188[(6)] = c__3814__auto___6189);

return statearr_6188;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___6189,channel,request_url,method,headers__$1,xhr,map__6166,map__6166__$1,request,request_method,headers,body,with_credentials_QMARK_,cancel))
);

} else {
}

return channel;
});
/**
 * Execute the JSONP request corresponding to the given Ring request
 *   map and return a core.async channel.
 */
cljs_http.core.jsonp = (function cljs_http$core$jsonp(p__6196){
var map__6197 = p__6196;
var map__6197__$1 = ((((!((map__6197 == null)))?(((((map__6197.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6197.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6197):map__6197);
var request = map__6197__$1;
var timeout = cljs.core.get.call(null,map__6197__$1,new cljs.core.Keyword(null,"timeout","timeout",-318625318));
var callback_name = cljs.core.get.call(null,map__6197__$1,new cljs.core.Keyword(null,"callback-name","callback-name",336964714));
var cancel = cljs.core.get.call(null,map__6197__$1,new cljs.core.Keyword(null,"cancel","cancel",-1964088360));
var channel = cljs.core.async.chan.call(null);
var jsonp = (new goog.net.Jsonp(cljs_http.util.build_url.call(null,request),callback_name));
jsonp.setRequestTimeout(timeout);

var req_6210 = jsonp.send(null,((function (channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel){
return (function cljs_http$core$jsonp_$_success_callback(data){
var response = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),(200),new cljs.core.Keyword(null,"success","success",1890645906),true,new cljs.core.Keyword(null,"body","body",-2049205669),cljs.core.js__GT_clj.call(null,data,new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true)], null);
cljs.core.async.put_BANG_.call(null,channel,response);

cljs.core.swap_BANG_.call(null,cljs_http.core.pending_requests,cljs.core.dissoc,channel);

if(cljs.core.truth_(cancel)){
cljs.core.async.close_BANG_.call(null,cancel);
} else {
}

return cljs.core.async.close_BANG_.call(null,channel);
});})(channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel))
,((function (channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel){
return (function cljs_http$core$jsonp_$_error_callback(){
cljs.core.swap_BANG_.call(null,cljs_http.core.pending_requests,cljs.core.dissoc,channel);

if(cljs.core.truth_(cancel)){
cljs.core.async.close_BANG_.call(null,cancel);
} else {
}

return cljs.core.async.close_BANG_.call(null,channel);
});})(channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel))
);
cljs.core.swap_BANG_.call(null,cljs_http.core.pending_requests,cljs.core.assoc,channel,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"jsonp","jsonp",226119588),jsonp,new cljs.core.Keyword(null,"request","request",1772954723),req_6210], null));

if(cljs.core.truth_(cancel)){
var c__3814__auto___6211 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___6211,req_6210,channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___6211,req_6210,channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel){
return (function (state_6203){
var state_val_6204 = (state_6203[(1)]);
if((state_val_6204 === (1))){
var state_6203__$1 = state_6203;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6203__$1,(2),cancel);
} else {
if((state_val_6204 === (2))){
var inst_6200 = (state_6203[(2)]);
var inst_6201 = jsonp.cancel(req_6210);
var state_6203__$1 = (function (){var statearr_6205 = state_6203;
(statearr_6205[(7)] = inst_6200);

return statearr_6205;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6203__$1,inst_6201);
} else {
return null;
}
}
});})(c__3814__auto___6211,req_6210,channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel))
;
return ((function (switch__3724__auto__,c__3814__auto___6211,req_6210,channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel){
return (function() {
var cljs_http$core$jsonp_$_state_machine__3725__auto__ = null;
var cljs_http$core$jsonp_$_state_machine__3725__auto____0 = (function (){
var statearr_6206 = [null,null,null,null,null,null,null,null];
(statearr_6206[(0)] = cljs_http$core$jsonp_$_state_machine__3725__auto__);

(statearr_6206[(1)] = (1));

return statearr_6206;
});
var cljs_http$core$jsonp_$_state_machine__3725__auto____1 = (function (state_6203){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_6203);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e6207){if((e6207 instanceof Object)){
var ex__3728__auto__ = e6207;
var statearr_6208_6212 = state_6203;
(statearr_6208_6212[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6203);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6207;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6213 = state_6203;
state_6203 = G__6213;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs_http$core$jsonp_$_state_machine__3725__auto__ = function(state_6203){
switch(arguments.length){
case 0:
return cljs_http$core$jsonp_$_state_machine__3725__auto____0.call(this);
case 1:
return cljs_http$core$jsonp_$_state_machine__3725__auto____1.call(this,state_6203);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs_http$core$jsonp_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs_http$core$jsonp_$_state_machine__3725__auto____0;
cljs_http$core$jsonp_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs_http$core$jsonp_$_state_machine__3725__auto____1;
return cljs_http$core$jsonp_$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___6211,req_6210,channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel))
})();
var state__3816__auto__ = (function (){var statearr_6209 = f__3815__auto__.call(null);
(statearr_6209[(6)] = c__3814__auto___6211);

return statearr_6209;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___6211,req_6210,channel,jsonp,map__6197,map__6197__$1,request,timeout,callback_name,cancel))
);

} else {
}

return channel;
});
/**
 * Execute the HTTP request corresponding to the given Ring request
 *   map and return a core.async channel.
 */
cljs_http.core.request = (function cljs_http$core$request(p__6214){
var map__6215 = p__6214;
var map__6215__$1 = ((((!((map__6215 == null)))?(((((map__6215.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6215.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6215):map__6215);
var request = map__6215__$1;
var request_method = cljs.core.get.call(null,map__6215__$1,new cljs.core.Keyword(null,"request-method","request-method",1764796830));
if(cljs.core._EQ_.call(null,request_method,new cljs.core.Keyword(null,"jsonp","jsonp",226119588))){
return cljs_http.core.jsonp.call(null,request);
} else {
return cljs_http.core.xhr.call(null,request);
}
});

//# sourceMappingURL=core.js.map
